EaBIM一直以来积极响应国家“十二五”推进建筑业信息化的号召,对建筑领域的信息技术开展深入技术交流和探讨!致力于打造“BIM-建筑师-生态技术”三位一体综合资源交流共享平台,希望为BIM与可持续设计理念及技术的普及做出微小的贡献!!!

EaBIM

 找回密码
 注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

搜索
查看: 1067|回复: 0
打印 上一主题 下一主题

[即时预览] 使用向导创建XLine Jig

[复制链接]

1514

主题

7465

帖子

1万

积分

admin

Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10Rank: 10

积分
12404

社区QQ达人

跳转到指定楼层
楼主
发表于 2014-1-8 14:56:46 | 只看该作者 回帖奖励 |倒序浏览 |阅读模式
AutoCAD .NET Addin Wizard (AcadNetAddinWizard) is far more than just some templates scattered around. It is a real-wizard-sense wizard, i.e. multi paged, configurable, flexible and intelligent. It also includes various project item wizards, coders, and widgets for AutoCAD .NET programming.
In this article, let us see how the Entity Jigger wizard of AutoCAD .NET Addin Wizard (AcadNetAddinWizard) can create a xline jigger automatically in no time for us.
The Entity Jigger wizard can be found from the Add New Item UI of both Visual C# and VB.NET of Visual Studio both full-fledged and Express in version both 2008 and 2010. Let’s take the C# of Visual Studio 2010 for an example. The AutoCAD Addin category will appear under the Visual C# Items node of the Installed Templates and its various item wizards including the Entity Jigger wizard appear in turn in the middle pane:
  1. <div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">
  2. The auto-generated Xline Jig class and test command may look like the following:</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">#region Namespaces</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">using System;
  3. using System.Text;
  4. using System.Linq;
  5. using System.Xml;
  6. using System.Reflection;
  7. using System.ComponentModel;
  8. using System.Collections;
  9. using System.Collections.Generic;
  10. using System.Windows;
  11. using System.Windows.Media.Imaging;
  12. using System.Windows.Forms;
  13. using System.Drawing;
  14. using System.IO;</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">using Autodesk.AutoCAD.ApplicationServices;
  15. using Autodesk.AutoCAD.DatabaseServices;
  16. using Autodesk.AutoCAD.Runtime;
  17. using Autodesk.AutoCAD.EditorInput;
  18. using Autodesk.AutoCAD.Geometry;
  19. using Autodesk.AutoCAD.Windows;</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">using MgdAcApplication = Autodesk.AutoCAD.ApplicationServices.Application;
  20. using MgdAcDocument = Autodesk.AutoCAD.ApplicationServices.Document;
  21. using AcWindowsNS = Autodesk.AutoCAD.Windows;</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">#endregion</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">namespace Acad2012NetDemoAddinCS
  22. {
  23.     public class EntityJigger1 : EntityJig
  24.     {
  25.         #region Fields</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        public int mCurJigFactorIndex = 1;  // Jig Factor Index</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        public Autodesk.AutoCAD.Geometry.Point3d mBasePoint; // Jig Factor #1
  26.         public Autodesk.AutoCAD.Geometry.Point3d mSecondPoint; // Jig Factor #2</div>
  27. <div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        #endregion</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        #region Constructors</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        public EntityJigger1(Xline ent)
  28.             : base(ent)
  29.         {
  30.             // Initialize and transform the Entity.
  31.             Entity.SetDatabaseDefaults();
  32.             Entity.TransformBy(UCS);</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        }</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        #endregion</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        #region Properties</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        private Editor Editor
  33.         {
  34.             get
  35.             {
  36.                 return MgdAcApplication.DocumentManager.MdiActiveDocument.Editor;
  37.             }
  38.         }</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        private Matrix3d UCS
  39.         {
  40.             get
  41.             {
  42.                 return MgdAcApplication.DocumentManager.MdiActiveDocument.Editor.CurrentUserCoordinateSystem;
  43.             }
  44.         }</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        #endregion</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        #region Overrides</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        public new Xline Entity  // Overload the Entity property for convenience.
  45.         {
  46.             get
  47.             {
  48.                 return base.Entity as Xline;
  49.             }
  50.         }</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        protected override bool Update()
  51.         {</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">            switch (mCurJigFactorIndex)
  52.             {
  53.                 case 1:
  54.                     Entity.BasePoint = mBasePoint;
  55.                     //Entity.BasePoint.TransformBy(UCS); //Turn it on for UCS transformation or tweak it if not compile.
  56.                     break;
  57.                 case 2:
  58.                     Entity.SecondPoint = mSecondPoint;
  59.                     //Entity.SecondPoint.TransformBy(UCS); //Turn it on for UCS transformation or tweak it if not compile.
  60.                     break;</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">                default:
  61.                     return false;
  62.             }</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">            return true;
  63.         }</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        protected override SamplerStatus Sampler(JigPrompts prompts)
  64.         {
  65.             switch (mCurJigFactorIndex)
  66.             {
  67.                 case 1:
  68.                     JigPromptPointOptions prOptions1 = new JigPromptPointOptions("\nBase point::");
  69.                     // Set properties such as UseBasePoint and BasePoint of the prompt options object if necessary here.
  70.                     prOptions1.UserInputControls = UserInputControls.Accept3dCoordinates | UserInputControls.GovernedByUCSDetect | UserInputControls.UseBasePointElevation;
  71.                     PromptPointResult prResult1 = prompts.AcquirePoint(prOptions1);
  72.                     if (prResult1.Status == PromptStatus.Cancel && prResult1.Status == PromptStatus.Error)
  73.                         return SamplerStatus.Cancel;</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">                    if (prResult1.Value.Equals(mBasePoint))  //Use better comparison method if necessary.
  74.                     {
  75.                         return SamplerStatus.NoChange;
  76.                     }
  77.                     else
  78.                     {
  79.                         mBasePoint = prResult1.Value;
  80.                         return SamplerStatus.OK;
  81.                     }
  82.                 case 2:
  83.                     JigPromptPointOptions prOptions2 = new JigPromptPointOptions("\nSecond point:");
  84.                     // Set properties such as UseBasePoint and BasePoint of the prompt options object if necessary here.
  85.                     prOptions2.UserInputControls = UserInputControls.Accept3dCoordinates | UserInputControls.GovernedByUCSDetect | UserInputControls.UseBasePointElevation;
  86.                     PromptPointResult prResult2 = prompts.AcquirePoint(prOptions2);
  87.                     if (prResult2.Status == PromptStatus.Cancel && prResult2.Status == PromptStatus.Error)
  88.                         return SamplerStatus.Cancel;</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">                    if (prResult2.Value.Equals(mSecondPoint) || prResult2.Value.Equals(mBasePoint))
  89.                     {
  90.                         return SamplerStatus.NoChange;
  91.                     }
  92.                     else
  93.                     {
  94.                         mSecondPoint = prResult2.Value;
  95.                         return SamplerStatus.OK;
  96.                     }</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">                default:
  97.                     break;
  98.             }</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">            return SamplerStatus.OK;
  99.         }</div>
  100. <div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        #endregion</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        #region Methods to Call</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        public static Xline Jig()
  101.         {
  102.             EntityJigger1 jigger = null;
  103.             try
  104.             {
  105.                 jigger = new EntityJigger1(new Xline());
  106.                 PromptResult pr;
  107.                 do
  108.                 {
  109.                     pr = MgdAcApplication.DocumentManager.MdiActiveDocument.Editor.Drag(jigger);
  110.                     if (pr.Status == PromptStatus.Keyword)
  111.                     {
  112.                         // Keyword handling code</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">                    }
  113.                     else
  114.                     {
  115.                         jigger.mCurJigFactorIndex++;
  116.                     }
  117.                 } while (pr.Status != PromptStatus.Cancel && pr.Status != PromptStatus.Error && jigger.mCurJigFactorIndex <= 2);</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">                if (pr.Status == PromptStatus.Cancel || pr.Status == PromptStatus.Error)
  118.                 {
  119.                     if (jigger != null && jigger.Entity != null)
  120.                         jigger.Entity.Dispose();</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">                    return null;
  121.                 }
  122.                 else
  123.                     return jigger.Entity;
  124.             }
  125.             catch
  126.             {
  127.                 if (jigger != null && jigger.Entity != null)
  128.                     jigger.Entity.Dispose();</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">                return null;
  129.             }
  130.         }</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        #endregion</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        #region Test Commands</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        [CommandMethod("TestEntityJigger1")]
  131.         public static void TestEntityJigger1_Method()
  132.         {
  133.             try
  134.             {
  135.                 Entity jigEnt = EntityJigger1.Jig();
  136.                 if (jigEnt != null)
  137.                 {
  138.                     Database db = HostApplicationServices.WorkingDatabase;
  139.                     using (Transaction tr = db.TransactionManager.StartTransaction())
  140.                     {
  141.                         BlockTableRecord btr = (BlockTableRecord)tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite);
  142.                         btr.AppendEntity(jigEnt);
  143.                         tr.AddNewlyCreatedDBObject(jigEnt, true);
  144.                         tr.Commit();
  145.                     }
  146.                 }
  147.             }
  148.             catch (System.Exception ex)
  149.             {
  150.                 MgdAcApplication.DocumentManager.MdiActiveDocument.Editor.WriteMessage(ex.ToString());
  151.             }
  152.         }</div><div align="left" style="color: rgb(105, 105, 105); font-family: 'Microsoft Yahei', Simsun; ">        #endregion
  153.     }
  154. }</div>
复制代码
The only code change needs to be made manually is to check if the second point equals to the base point and do nothing if true. Apart from this tiny point, the auto-generated code works well, including taking care of user cancelations and honoring the current UCS. The following demonstrates how it behaves in AutoCAD.

The Entity Jigger wizard of the leading edge AutoCAD .NET Addin Wizard (AcadNetAddinWizard)can help you create EntityJig derivatives for various entity types automatically, quickly, reliably and professionally.

分享到:  QQ好友和群QQ好友和群 QQ空间QQ空间 腾讯微博腾讯微博 腾讯朋友腾讯朋友 微信微信
收藏收藏 转播转播 分享分享 分享淘帖 支持支持 反对反对

相关帖子

工作时间:工作日的9:00-12:00/13:30-18:00,节假日不在线,请勿留言
*滑块验证:
您需要登录后才可以回帖 登录 | 注册

本版积分规则

QQ|EaBIM网 ( 苏ICP备2020058923号-1  苏公网安备32011502011255号

GMT+8, 2024-11-16 11:14

Powered by Discuz! X3.2 Licensed

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表